#define  SEND_CMD(A)   PORTE.F2=0; PORTE.F1=1; PORTD = A;  PORTE.F1=0;
#define  SEND_DATA(A)  PORTE.F2=1; PORTE.F1=1; PORTD = A;  PORTE.F1=0;

  /*
 * Project name:
     LED_Blinking (Simple 'Hello World' project)
 * Copyright:
     (c) MikroElektronika, 2005-2008
 * Description:
     This is a simple 'Hello World' project. It turns on/off diodes connected to
     PORTC. It uses bitwise negation to toggle PORTC pins.
 * Test configuration:
     MCU:             PIC16F877A
     Dev.Board:       EasyPIC5
     Oscillator:      HS, 08.0000 MHz
     Ext. Modules:    -
     SW:              mikroC v8.0
 * NOTES:
     None.
*/

void main() {
  unsigned int  temp_res, temp_res2;
  unsigned char  temperature;
  char text[16];
  char value[5]="000";
  char keypressed=0;
  char var2;
  int i, val;
  
  

  TRISE = 0;
  TRISD = 0;
  TRISC =0;

  PORTE =0;
  PORTD =0;
  PORTC =0x00;
  
  //Manual control of LCD Display without libraries

  PORTE.F1 =0;
  delay_ms(100);

  delay_ms(100);

  PORTD = 0b00110000;  //set 8 bit  mode  2 lines 5x8 ROM
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(100);

  PORTD = 0b00110000;  //set 8 bit  mode  2 lines 5x8 ROM
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(100);

  PORTD = 0b00110000;  //set 8 bit  mode  2 lines 5x8 ROM
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(100);

  PORTD =  0b00001100;  // display  ON/OFF
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(100);

  PORTD =  0b00000001; //clear display
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);

  PORTD =  0b00000110;  //set entry mode;
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(100);

  PORTD =  0b01000001;  //write A;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);

  PORTD =  0b01000010;  //write B;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);
  
  PORTD =  0b00000001;  //clear display
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);

  PORTD =  0b01000011;  //write C;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);
  
  // Here we create a custom character in the CGRAM of the display;
  PORTD =0b01001000; //Set CGRAM to AC
  PORTE.F2 = 0;      //RS = 0
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  PORTD =0b00011111; //Write 11111 to 1st row
  PORTE.F2 = 1;      //RS = 1 to write to address specifed above.
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  PORTD =0b00010001; //Write 10001 to 2nd row
  PORTE.F2 = 1;      //RS = 1 to write to address specifed above.
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  PORTD =0b0001010; //Write 01010 to 3rd row
  PORTE.F2 = 1;      //RS = 1 to write to address specifed above.
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  PORTD =0b0001110; //Write 01110 to 4th row
  PORTE.F2 = 1;      //RS = 1 to write to address specifed above.
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;


  //hopefully here we have a custom character in the LCD CGRAM.

  PORTD = 0b10001000; //Set DDRAM ADRESS to Specify position n display.
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  PORTD =  0b00000001;   //write from CCGRAM 0;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  //while(1);


  delay_ms(1000);
  for (i=32; i<255; i++) {

      PORTD = 0b10001000; //Set DDRAM ADRESS to Specify position n display.
      PORTE.F2 = 0;
      PORTE.F1=1;        // pulse to enable
      PORTE.F1=0;

      PORTD =  i; // 0b01000001;  //write A;
      PORTE.F2 = 1;
      PORTE.F1=1;        // pulse to enable
      PORTE.F1=0;
      delay_ms(500);
  }

  PORTD =  0b01000010;  //write B;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);

  PORTD =  0b00000001;  //clear display
  PORTE.F2 = 0;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);

  PORTD =  0b01000011;  //write C;
  PORTE.F2 = 1;
  PORTE.F1=1;        // pulse to enable
  PORTE.F1=0;

  delay_ms(1000);
  
  //use of libraries for lcd in 8 bit mode


  Lcd8_Config(&PORTE, &PORTD, 2,1,0, 7,6,5,4,3,2,1,0);
  Lcd8_Cmd(LCD_CLEAR);
  Lcd8_Out(1,1,"LCD LIBRARY TEST");

  delay_ms(1000);

  Lcd8_Cmd(LCD_CLEAR);
  Lcd8_Out(1,1,"KEYPAD TEST");

  
  
  // READ keypad and display

   PORTD = 0xFF;
   TRISD = 0xFF;
   TRISB = 0;
   portb = 0xff;


   for (i =0; i<3;i++ ) {
       keypressed =0;
       do {

           // scan first column
           portb.f0 = 0;
           TRISD = 0xff;
           var2 = PORTD;
           TRISD = 0x00;
           if (var2.f0 == 0)      keypressed = '<';
           else if (var2.f1 == 0) keypressed = '7';
           else if (var2.f2 == 0) keypressed = '4';
           else if (var2.f3 == 0) keypressed = '1';
           portb.f0 =1;

           // scan second column
           portb.f1 = 0;
           TRISD = 0xff;
           var2 = PORTD;
           TRISD = 0x00;
           if (var2.f0 == 0)      keypressed = '0';
           else if (var2.f1 == 0) keypressed = '8';
           else if (var2.f2 == 0) keypressed = '5';
           else if (var2.f3 == 0) keypressed = '2';
           portb.f1 =1;

           // scan third column
           portb.f2 = 0;
           TRISD = 0xff;
           var2 = PORTD;
           TRISD = 0x00;
           if (var2.f0 == 0)      keypressed = '>';
           else if (var2.f1 == 0) keypressed = '9';
           else if (var2.f2 == 0) keypressed = '6';
           else if (var2.f3 == 0) keypressed = '3';
           portb.f2 =1;
      

      } while (keypressed == 0);

   Lcd8_Chr(2,i+1,keypressed);
   value[i] = keypressed;
   
   Lcd8_Out(1,13,value);
   delay_ms(500);
   }


   delay_ms(2000);
   Lcd8_Cmd(LCD_CLEAR);
   Lcd8_Out(1,1,"ADC TEST");
   
    val = (value[0]-48)*100 + (value[1]-48)*10 + (value[2]-48) ;
    
    wordToStr(val,text);
    Lcd8_Out(1,10,text);



  ADCON1 = 0x0C;  // Configure analog inputs and Vref
  TRISA  = 0xFF;  // PORTA is input

  Lcd8_Out(2,1, value);

  do {
    temp_res = Adc_Read(0);

    wordToStr(temp_res, text);
    Lcd8_Out(2,5, text);
    delay_ms(20);
    
    temp_res2 = Adc_Read(1);
    wordToStr(temp_res2, text);
    Lcd8_Out(2,10, text);
    delay_ms(20);
    

    
    if (temp_res > val) PORTC.F2 =1;
    else  PORTC.F2 =0;

    
  } while(1);


  delay_ms(1000);



}
